#include "StdAfx.h"
#include "RecentUsedStickers.h"
#include "StickerItem.h"
#include <algorithm>

CStickersCollection::CStickersCollection(void)
{
}

CStickersCollection::~CStickersCollection(void)
{
}

bool CStickersCollection::Insert( CStickerItem *obj )
{
	if(obj)
	{
		if(FindObjByID(obj, &m_list))
			return false;
		m_list.push_front(obj);
		return true;
	}else
		return false;
}

void CStickersCollection::Release()
{
	for (CStickerItemList::iterator iter = m_list.begin();
		iter != m_list.end();
		++iter)	{
		CStickerItem* pItem = *iter;

		if (!pItem)
			continue;

		SAFE_DELETE(pItem->m_img);
		SAFE_DELETE(pItem);
	}

	m_list.clear();
}

CStickerItem* CStickersCollection::FindObjByID( CStickerItem * obj , CStickerItemList *list,CStickerItem** foundObj)
{
   CStickerItem* res = NULL;
   CString gid = obj->m_strGroupID;
   CString id = obj->m_strStickerID;

   for (CStickerItemList::iterator iter = list->begin();
	   iter != list->end();
	   ++iter)
   {
	   CStickerItem *p = *iter;

	   if(0== p->m_strGroupID.CompareNoCase(gid) &&  0==p->m_strStickerID.CompareNoCase(id))
	   {
		   res = p;
		   break;
	   }

   }

   if(res)
	   return res;
   else
	   return NULL;

}

void CStickersCollection::RemoveObj( CStickerItem * p )
{
	if(p)
	{
		m_list.remove(p);
	}
}

UINT CStickersCollection::GetSize(){

   return m_list.size();

}

void CStickersCollection::FreeObj( CStickerItem * p )
{
	if(p)
	{
		delete p;
		p = NULL;
	}
}



/*
void CStickersCollection::Resort()
{
	m_list.sort(RhythmObject_Trait());
}*/